summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorThomas Deutschmann <whissi@gentoo.org>2017-11-06 17:20:43 +0100
committerThomas Deutschmann <whissi@gentoo.org>2017-11-06 17:20:57 +0100
commit0edff67f453a7509c08fce538d3da9c947daa433 (patch)
treedd0037bc5e913e7c70f7a3c63196f2432b7759d3
parentdev-cpp/waylandpp: version bump 0.1.4 (diff)
downloadgentoo-0edff67f453a7509c08fce538d3da9c947daa433.tar.gz
gentoo-0edff67f453a7509c08fce538d3da9c947daa433.tar.bz2
gentoo-0edff67f453a7509c08fce538d3da9c947daa433.zip
sys-apps/coreutils: Rev bump to address multiple test failures
- Running test suite with FEATURES=usersandbox is no longer supported due to various sandbox issues. (bug #413621, #439574, #629660) - Due to sandbox failures previously disabled tests re-enabled. (bug #415487) - tests/ls/readdir-mountpoint-inode test failure fixed. (bug #353164) - "caps" USE flag description more specified. (bug #617702 - Tools/programs/libraries used in test suite now listed in DEPEND="test? (...)" which requires re-keywording for some architectures. Bug: https://bugs.gentoo.org/413621 Bug: https://bugs.gentoo.org/439574 Bug: https://bugs.gentoo.org/629660 Bug: https://bugs.gentoo.org/415487 Closes: https://bugs.gentoo.org/353164 Closes: https://bugs.gentoo.org/617702 Package-Manager: Portage-2.3.13, Repoman-2.3.4
-rw-r--r--sys-apps/coreutils/Manifest1
-rw-r--r--sys-apps/coreutils/coreutils-8.28-r1.ebuild210
-rw-r--r--sys-apps/coreutils/metadata.xml1
3 files changed, 212 insertions, 0 deletions
diff --git a/sys-apps/coreutils/Manifest b/sys-apps/coreutils/Manifest
index bee926f1d1e..ad565d4c64d 100644
--- a/sys-apps/coreutils/Manifest
+++ b/sys-apps/coreutils/Manifest
@@ -9,4 +9,5 @@ DIST coreutils-8.27-patches-1.1.tar.xz 7800 SHA256 8b8996a38913971c955c7b7e428d0
DIST coreutils-8.27.tar.xz 5285648 SHA256 8891d349ee87b9ff7870f52b6d9312a9db672d2439d289bc57084771ca21656b SHA512 abf3280aaa54e9bd5851df0eda2af1de1017ca174633e52d1e592455d46ea0e99812dda46d2f320e979553cef271485d8818c595bba6ed31264511a511c93679 WHIRLPOOL dcc092f41fb4802563062a4aa5a71e2841a7ddc46dec4acc47af3d9a4bee2372ddae7990ac6f3cf00568f43c3103c8290338964040e111861f080e064960803d
DIST coreutils-8.28-man.tar.xz 43832 SHA256 d72c3fa79ae328a4fd1107102e8946755aa2e908044e1efcf1e71ef206dca042 SHA512 363cf595e0f6fc69eb6a9d1ca258a5f012404cee99887494ab6e40fe2c6de5e49e7cad953aecb394c5612043efe6b407e657811d8251b10e159c97b849dd8b3e WHIRLPOOL 7b10dbde06caf00d4b789cdb60a7d0c73aec65a90e889698daeccd04eefd8df08142261ea5fde8d3d455f35b2eddf07182bf92e2522e63e8ece412379e0cb0d1
DIST coreutils-8.28-patches-1.0.tar.xz 7264 SHA256 fe9e8f347d104472d357ad80212996d0c9ddb97cec6166d38f4c340a02f4633c SHA512 b358b827eaff789ea8a3838f53f81efb08a6caa5318ac93dab112ec90052174c05d219e1c0170106bb1ed65bd4e37ffc36b742bf3661cc64ee4b166db741bbbc WHIRLPOOL ece3be79d296507341433bf60b0e7bd6846c3d0a8acfff19d1fba17ec45a13f5504c41bb320bd39358ae9f5e2efd5311e2a7ef6ec1119872f990455f9aa9c94d
+DIST coreutils-8.28-patches-1.1.tar.xz 7336 SHA256 bdd7ed0ef973bc1095df329225659a928ed061695651e2b54de79ac15690f517 SHA512 af47aaa614550e5cd82b2386fafd9f90beb0564b8bbedfe92238906e7c6f040fb7468c1929f0951d4f98038b6e1df7da2408204be78219e6a041658507385957 WHIRLPOOL 4a90ffa0a35b81d3d20c29128b0d39e08136d499201ac875781d9e851142d36c111031b333b6bfb81db692e75e7b3cc9673c4339d8d183d0d8df2371444dca4e
DIST coreutils-8.28.tar.xz 5252336 SHA256 1117b1a16039ddd84d51a9923948307cfa28c2cea03d1a2438742253df0a0c65 SHA512 1e592d0dd03b9227bf92af9a82bed6dc3bcbee46e984c7fb09833dea0962e86b309aa34d5e43823b73d4522c066bfa5cdc8ec694aa190910fb246ff32ceb63a1 WHIRLPOOL 58bdd9681d07794da70dc012d03de2f791bc8e40a16de85302cbb5ea247f6d81f0a92c3b90d655b9947057c5e5eb99b9347152d41150c1a613dd1f891942a73f
diff --git a/sys-apps/coreutils/coreutils-8.28-r1.ebuild b/sys-apps/coreutils/coreutils-8.28-r1.ebuild
new file mode 100644
index 00000000000..e4ab5f9b371
--- /dev/null
+++ b/sys-apps/coreutils/coreutils-8.28-r1.ebuild
@@ -0,0 +1,210 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+# To generate the man pages, unpack the upstream tarball and run:
+# ./configure --enable-install-program=arch,coreutils,hostname,kill
+# make
+# cd ..
+# tar cf - coreutils-*/man/*.[0-9] | xz > coreutils-<ver>-man.tar.xz
+
+EAPI="6"
+
+PYTHON_COMPAT=( python{2_7,3_4,3_5} )
+
+inherit eutils flag-o-matic python-any-r1 toolchain-funcs
+
+PATCH_VER="1.1"
+DESCRIPTION="Standard GNU utilities (chmod, cp, dd, ls, sort, tr, head, wc, who,...)"
+HOMEPAGE="https://www.gnu.org/software/coreutils/"
+SRC_URI="mirror://gnu/${PN}/${P}.tar.xz
+ mirror://gentoo/${P}-patches-${PATCH_VER}.tar.xz
+ https://dev.gentoo.org/~whissi/dist/${PN}/${P}-patches-${PATCH_VER}.tar.xz
+ mirror://gentoo/${P}-man.tar.xz
+ https://dev.gentoo.org/~polynomial-c/dist/${P}-man.tar.xz"
+
+LICENSE="GPL-3"
+SLOT="0"
+KEYWORDS="~amd64 ~m68k ~ppc ~s390 ~sh ~sparc ~x86 ~arm-linux ~x86-linux"
+IUSE="acl caps gmp hostname kill multicall nls selinux static test userland_BSD vanilla xattr"
+
+LIB_DEPEND="acl? ( sys-apps/acl[static-libs] )
+ caps? ( sys-libs/libcap )
+ gmp? ( dev-libs/gmp:=[static-libs] )
+ xattr? ( !userland_BSD? ( sys-apps/attr[static-libs] ) )"
+RDEPEND="!static? ( ${LIB_DEPEND//\[static-libs]} )
+ selinux? ( sys-libs/libselinux )
+ nls? ( virtual/libintl )"
+DEPEND="${RDEPEND}
+ static? ( ${LIB_DEPEND} )
+ app-arch/xz-utils
+ test? (
+ dev-lang/perl
+ dev-perl/Expect
+ !userland_BSD? (
+ dev-util/strace
+ )
+ ${PYTHON_DEPS}
+ $(python_gen_any_dep 'dev-python/pyinotify[${PYTHON_USEDEP}]')
+ )"
+RDEPEND+="
+ hostname? ( !sys-apps/net-tools[hostname] )
+ kill? (
+ !sys-apps/util-linux[kill]
+ !sys-process/procps[kill]
+ )
+ !app-misc/realpath
+ !<sys-apps/util-linux-2.13
+ !<sys-apps/sandbox-2.10-r4
+ !sys-apps/stat
+ !net-mail/base64
+ !sys-apps/mktemp
+ !<app-forensics/tct-1.18-r1
+ !<net-fs/netatalk-2.0.3-r4"
+
+pkg_setup() {
+ if use test ; then
+ python-any-r1_pkg_setup
+ fi
+}
+
+src_prepare() {
+ if ! use vanilla ; then
+ use_if_iuse unicode || rm -f "${WORKDIR}"/patch/000_all_coreutils-i18n.patch
+ #rm "${WORKDIR}"/patch/001_all_coreutils-gen-progress-bar.patch || die
+ eapply "${WORKDIR}"/patch/*.patch
+ fi
+
+ eapply_user
+
+ # Since we've patched many .c files, the make process will try to
+ # re-build the manpages by running `./bin --help`. When doing a
+ # cross-compile, we can't do that since 'bin' isn't a native bin.
+ # Also, it's not like we changed the usage on any of these things,
+ # so let's just update the timestamps and skip the help2man step.
+ set -- man/*.x
+ touch ${@/%x/1}
+
+ # Avoid perl dep for compiled in dircolors default #348642
+ if ! has_version dev-lang/perl ; then
+ touch src/dircolors.h
+ touch ${@/%x/1}
+ fi
+}
+
+src_configure() {
+ local myconf=(
+ --with-packager="Gentoo"
+ --with-packager-version="${PVR} (p${PATCH_VER:-0})"
+ --with-packager-bug-reports="https://bugs.gentoo.org/"
+ --enable-install-program="arch,$(usev hostname),$(usev kill)"
+ --enable-no-install-program="groups,$(usev !hostname),$(usev !kill),su,uptime"
+ --enable-largefile
+ $(use caps || echo --disable-libcap)
+ $(use_enable nls)
+ $(use_enable acl)
+ $(use_enable multicall single-binary)
+ $(use_enable xattr)
+ $(use_with gmp)
+ )
+ if tc-is-cross-compiler && [[ ${CHOST} == *linux* ]] ; then
+ export fu_cv_sys_stat_statfs2_bsize=yes #311569
+ export gl_cv_func_realpath_works=yes #416629
+ fi
+
+ export gl_cv_func_mknod_works=yes #409919
+ use static && append-ldflags -static && sed -i '/elf_sys=yes/s:yes:no:' configure #321821
+ use selinux || export ac_cv_{header_selinux_{context,flash,selinux}_h,search_setfilecon}=no #301782
+ use userland_BSD && myconf+=( -program-prefix=g --program-transform-name=s/stat/nustat/ )
+ # kill/uptime - procps
+ # groups/su - shadow
+ # hostname - net-tools
+ econf ${myconf[@]}
+}
+
+src_test() {
+ # Known to fail with FEATURES=usersandbox (bug #439574):
+ # - tests/du/long-from-unreadable.sh} (bug #413621)
+ # - tests/rm/deep-2.sh (bug #413621)
+ # - tests/dd/no-allocate.sh (bug #629660)
+ if has usersandbox $FEATURES ; then
+ ewarn "You are emerging ${P} with 'usersandbox' enabled." \
+ "Expect some test failures or emerge with 'FEATURES=-usersandbox'!"
+ fi
+
+ # Non-root tests will fail if the full path isn't
+ # accessible to non-root users
+ chmod -R go-w "${WORKDIR}"
+ chmod a+rx "${WORKDIR}"
+
+ # coreutils tests like to do `mount` and such with temp dirs
+ # so make sure /etc/mtab is writable #265725
+ # make sure /dev/loop* can be mounted #269758
+ mkdir -p "${T}"/mount-wrappers
+ mkwrap() {
+ local w ww
+ for w in "$@" ; do
+ ww="${T}/mount-wrappers/${w}"
+ cat <<-EOF > "${ww}"
+ #!${EPREFIX}/bin/sh
+ exec env SANDBOX_WRITE="\${SANDBOX_WRITE}:/etc/mtab:/dev/loop" $(type -P $w) "\$@"
+ EOF
+ chmod a+rx "${ww}"
+ done
+ }
+ mkwrap mount umount
+
+ addwrite /dev/full
+ #export RUN_EXPENSIVE_TESTS="yes"
+ #export FETISH_GROUPS="portage wheel"
+ env PATH="${T}/mount-wrappers:${PATH}" \
+ emake -j1 -k check
+}
+
+src_install() {
+ default
+
+ insinto /etc
+ newins src/dircolors.hin DIR_COLORS
+
+ if [[ ${USERLAND} == "GNU" ]] ; then
+ cd "${ED%/}"/usr/bin || die
+ dodir /bin
+ # move critical binaries into /bin (required by FHS)
+ local fhs="cat chgrp chmod chown cp date dd df echo false ln ls
+ mkdir mknod mv pwd rm rmdir stty sync true uname"
+ mv ${fhs} ../../bin/ || die "could not move fhs bins"
+ if use kill; then
+ mv kill ../../bin/ || die
+ fi
+ # move critical binaries into /bin (common scripts)
+ local com="basename chroot cut dir dirname du env expr head mkfifo
+ mktemp readlink seq sleep sort tail touch tr tty vdir wc yes"
+ mv ${com} ../../bin/ || die "could not move common bins"
+ # create a symlink for uname in /usr/bin/ since autotools require it
+ local x
+ for x in ${com} uname ; do
+ dosym ../../bin/${x} /usr/bin/${x}
+ done
+ else
+ # For now, drop the man pages, collides with the ones of the system.
+ rm -rf "${ED%/}"/usr/share/man
+ fi
+
+}
+
+pkg_postinst() {
+ ewarn "Make sure you run 'hash -r' in your active shells."
+ ewarn "You should also re-source your shell settings for LS_COLORS"
+ ewarn " changes, such as: source /etc/profile"
+
+ # Help out users using experimental filesystems
+ if grep -qs btrfs "${EROOT%/}"/etc/fstab /proc/mounts ; then
+ case $(uname -r) in
+ 2.6.[12][0-9]|2.6.3[0-7]*)
+ ewarn "You are running a system with a buggy btrfs driver."
+ ewarn "Please upgrade your kernel to avoid silent corruption."
+ ewarn "See: https://bugs.gentoo.org/353907"
+ ;;
+ esac
+ fi
+}
diff --git a/sys-apps/coreutils/metadata.xml b/sys-apps/coreutils/metadata.xml
index b75c0df6a5f..9241968a469 100644
--- a/sys-apps/coreutils/metadata.xml
+++ b/sys-apps/coreutils/metadata.xml
@@ -8,6 +8,7 @@
<longdescription>Standard GNU file utilities (chmod, cp, dd, dir, ls, ...), text utilities (sort, tr, head, wc, ...), and shell utilities (whoami, who, ...)
</longdescription>
<use>
+ <flag name="caps">Add Linux capabilities support in output of file utilities (ls, dir, ...) via <pkg>sys-libs/libcap</pkg></flag>
<flag name="hostname">Build the hostname program</flag>
<flag name="kill">Build the kill program</flag>
<flag name="multicall">Build all tools into a single `coreutils` program akin to busybox to save space</flag>